[转] NPM 版本控制

原地址 : NPM 版本控制

优秀链接:

NPM版本计算器

为了在软件版本号中包含更多意义,反映代码所做的修改,产生了语义化版本,软件的使用者能从版本号中推测软件做的修改。npm 包使用语义化版控制,我们可安装一定版本范围的 npm 包,npm 会选择和你指定的版本相匹配(latest)最新版本安装。
npm 的版本号由三部分组成:
主版本号次版本号补丁版本号。变更不同的版本号,代表不同的意义:

  • 主版本号(major):软件做了不兼容的变更(breaking change 重大变更);
  • 次版本号(minor):添加功能或者废弃功能,向下兼容;
  • 补丁版本号(patch):bug 修复,向下兼容。

有时候为了表达更加确切的版本,还会在版本号后面添加标签或者扩展,来说明是预发布版本或者测试版本等。比如 3.2.3-beta-3

常见的标签有 :

标签 意义 补充
demo demo版本 可能用于验证问题的版本
dev 开发版 开发阶段用的,bug 多,体积较大等特点,功能不完善
alpha α版本 用于内部交流或者测试人员测试,bug较多
beta 测试版(β版本) 较α版本,有较大的改进,但是还是有bug
gamma (γ)伽马版本 较α和β版本有很大的改进,与稳定版相差无几,用户可使用
trial 试用版本 本软件通常都有时间限制,过期之后用户如果希望继续使用,一般得交纳一定的费用进行注册或购买。有些试用版软件还在功能上做了一定的限制。
stable 稳定版
csp 内容安全版本 js库常用
latest 最新版本 不指定版本和标签,npm 默认安最新版

更多关于标签的内容

查看标签:

1
npm dist-tags ls <pkg>
1
npm dist-tags ls vue

得到:

1
2
3
beta: 2.6.0-beta.3
csp: 1.0.28-csp
latest: 2.6.10

安装带标签的版本

1
npm i <pkg>@<tag>
1
npm i vue@beta # 安装 2.6.0-beta.3

版本号变更规则

  1. 版本号只升不降,不得在数字前加0,比如 2.01.2 不允许的;
  2. 0.y.z,处于开发阶段的版本;
  3. 第一个正式版版本往往命名为 1.0.0;
  4. 先行版本必须在补丁版本之后添加,比如 2.3.7-0,0表示先行版本,和补丁版本用-分隔;
  5. 版本的比较依次比较主版本次版本补丁版本先行版本,直到第一个能得出比较结果为止;
  6. 不小心把一个不兼容的改版当成了次版本号发行了该怎么办?一旦发现自己破坏了语义化版本控制的规范,就要修正这个问题,并发行一个新的次版本号来更正这个问题并且恢复向下兼容。即使是这种情况,也不能去修改已发行的版本。

NPM版本计算器

如何处理即将弃用的功能?

弃用现存的功能是软件开发中的家常便饭,也通常是向前发展所必须的。但当你弃用公共API的一部分时,你应该做两件事:
(1)更新文档以便使用者知道这个变化。
(2)发行不包含弃用功能的次版本。在新主版本中完全移除弃用功能前,至少应有一个不包含弃用功能的次版本发布,以便使用者能够平滑过渡到新的API。

如何更新版本号?不用手动修改 package.json。而是用如下命令:

1
npm version [<newversion> | major | minor | patch | premajor | preminor | prepatch | prerelease | from-git]
  1. newversion: 直接给一个版本号;
  2. major: 主版本增加1;
  3. premajor: 预备主版本,主版本增加1,增加先行版本号;
  4. prelease: 预先发布版本,先行版本号增加1;

git 和 npm version 结合

手动更改版本号

执行 npm version <version> -m 'xx %s xx' 改变npm版本的同时,会执行一次 git commt -m 'xx %s xx'并用版本号打一个tag,%s 会替换成版本号,前提是版本库是干净的(clean)

自动更新版本

.git/hooks目录内,新建post-commit,输入以下内容:

1
2
3
4
5
6
7
#!/bin/sh
COMMIT_MSG="$(git log --pretty=format:"%s" -1 head)"
echo "$COMMIT_MSG" | grep -q "^[0-9]"
if [ $? -ne 0 ];then
# 自动修改 patch
echo $(npm version patch)
fi

在执行 git commit -m 'message'后,会检测message是否是版本号(y.x.z的形式),不是,则执行 npm version patch更新补丁版本,打一个tag。

如果想自动修改次版本,post-commit 的内容即可。

版本运算符

版本运算符指定了一定范围的版本。
主要有**~^-、、>==**版本运算符。

~ 版本号 —– 指定主版本号或者次版本号相同

~ + 只含主版本 — 主版本相同;
~ + 含有次版本 — 主版本和次版本号相同。

版本范围 匹配版本
~3 3.x 或者 3.0.0  版本号相同
版本范围 匹配版本 补充
^3.1.5 3.1.5  和 ≈ 差不多,可将 ~ 理解成相似,这样就分辨和理解了,~指定的是相似版本

^ 可理解成兼容版本

- 指定精确范围

版本范围 匹配版本 补充
2.0.0 - 3.2.7 2.0.0 4.2.0 大于4.2.0 的版本
>=4.2.0 大于等于 4.2.0 的版本
=4.3.0 等于 4.3.0 的版本

\ 是转义字符。

1
2
3
4
5
npm i lodash@\<3.5 # 安装 3.4.0
npm i lodash@\<=3.5 # 安装 3.5.0
npm i lodash@\>3.5 # 安装 4.17.11
npm i lodash@\>=3.5 # 安装 4.17.11
npm i vue@">1 <2.3" # 安装 2.2.6

分组 ||

或者的关系连接两个版本范围,极少使用。

1
npm i vue@"^0.7 || ~2" # 安装 2.6.10

参考


语雀镜像 : [转] NPM 版本控制 ,点此 提问

作者

Duoli

发布于

2021-06-14

更新于

2022-12-08

许可协议

评论